/*! \file *******************************************************************
*
* Atmel Corporation
*
* ̧       : main.c
* ߲     : IAR EWAAVR 2.28a/3.10c
* Rev.       : $Revision: 1.1 $
* t       : $Date: Wednesday, July 13, 2005 10:43:44 UTC $
* XV     : $Author: omella $
*
* xҰ    : avr@atmel.com
*
* x޲ : A/Dϊ킪gpłS޲BATmega16pɏĂ܂B
*
* pLq   : AVR121 - ߍ̎ɂA/Dϊ\
*
* De      : \̂߂̉ߍ̎gp@̗
*              eϊ10ޯČʂUARTɏ܂B
*              109610ޯč̎16ޯČʂUARTɏ܂B
*
****************************************************************************/
#include <iom16.h>
#include <inavr.h>

// S̕ϐ
double        accumulator       = 0;          //!< 10ޯč̎ݐϒl
double        result            = 0;          //!< ASCIIϐ
double        Vin               = 0;          //!< 16ޯĂ̌ʒl
short         temp              = 0;          //!< ꎞϐ
short         samples           = 0;	      //!< 10ޯč̎vl

// ֐
void send(unsigned char result);
void write_ascii(double accumulator);
void init_adc(void);
void init_uart(void);
void init_counter(void);
void vin(void);
void write_10bit(void);
void write_16bit(void);
void oversampled(void);
void write_space(void);

//! A/Dϊ荞ݏٰ
#pragma vector=ADC_vect
__interrupt void ADCinterrupt(void)
{
  accumulator += ADC;
  samples++;
}

//! A/Dϊۯ125kHz,VREF=AREFA/Dϊ틖AA/Dϊ荞݋
void init_adc(void)
{
  ADCSRA = (1<<ADEN)|(1<<ADIE)|(1<<ADSC)|(1<<ADATE)|(1<<ADPS2)|(1<<ADPS1);
  ADMUX = (0<<REFS1)|(0<<REFS0);
  __enable_interrupt();
}

/*! \brief 8MHz ۯ19200bps,8ޯ,1į ޯ,èȂ,MUART */
void init_uart(void)
{
  UBRRL = 25;
  UCSRB = (1<<TXEN);
}

//! Mޯ̧󂫑ҋ@AΉްMJn
void send(unsigned char result)
{
  while (!(UCSRA & (1<<UDRE)));
  UDR = result;
}

//! PWM,64ۯ,CTC,(OC2)50%ޭè/2
void init_counter(void)
{
  DDRD  = (1<<PD7);
  TCCR2 = (1<<WGM20)|(1<<WGM21)|(1<<COM21)|(1<<CS22);
  OCR2  = 128;
}

//! ASCIIϊAʂUARTM
void write_ascii(double accumulator)
{
  unsigned char result;
  result = '0';
  while ( accumulator >= 10000 )
  {
    result++;
    accumulator -= 10000;
  }
  send(result);                              // 擪M

  result = '0';
  while ( accumulator >= 1000 )
  {
    result++;
    accumulator -= 1000;
  }
  send(result);                              // 2M

  result = '0';
  while ( accumulator >= 100 )
  {
    result++;
    accumulator -= 100;
  }
  send(result);                              // 3M

  result = '0';
  while ( accumulator >= 10 )
  {
    result++;
    accumulator -= 10;
  }
  send(result);                              // 4M

  send('0' + accumulator);                   // 5M
  send('\r');                                // CRM
  send('\n');                                // LFM
}

//! 16ޯČʌvZ
void vin(void)
{
  Vin = (accumulator/65536)*4.910;	     // VREF=4.910
}

//! A/DϊUARTM
void write_10bit(void)
{
  __disable_interrupt();
  write_ascii(ADC);
  __enable_interrupt();
}

//! 16ޯČUARTM
void write_16bit(void)
{
  __disable_interrupt();
  write_ascii(accumulator);
  __enable_interrupt();
}

//! 16ޯČʂ̑O''M
void write_space(void)
{
  int i;
  for(i=0; i<4; i++)
    {
      send(32);                                 // 󔒕M
    }
}

/*! \brief 덷⏞,ړx␳,ۂ,ςʑ */
void oversampled(void)
{
  __disable_interrupt();
  accumulator += 5150;                         // ̾Č덷⏞ (69*4096)/64*/
  accumulator *= 0.9993;                       // 덷⏞
  temp=(int)accumulator%64;
  accumulator/=64;
  if(temp>=32)
    {
      accumulator += 1;                       //  ۂ
    }
  write_space();
  write_16bit();
  vin();
  samples     = 0;
  accumulator = 0;
  __enable_interrupt();
}

void main( void )
{
  init_uart();
  init_adc();
  init_counter();

  while(1)
  {
    write_10bit();
    if(samples>4095)
      {
        oversampled();
      }
  }
}

